from axipy import provider_manager, Rectangle, CoordSystem, Table, Schema, Point, Feature

from RegisterVector.ui.add.affine_transform import DescriptorTransform
def FeatureClone(ft:Feature,new_geo):
    attr_temp=ft.items()
    attr= {}
    for att in attr_temp:
        if att[0]=='+geometry' or att[0]=='+style':
            continue
        attr[att[0]]=att[1]

    return Feature(attr,geometry=new_geo,style=ft.style)

def CreateOutFile(path_out, schema: Schema):
    tab = provider_manager.tab.create_open(path_out, schema)
    return tab


def CreateOutTabFileInvert(tab_source: Table, cs_out: CoordSystem, transform, path_out):
    if not cs_out.non_earth:
        new_schema = tab_source.schema
        new_schema.coordsystem = cs_out
        return CreateOutFile(path_out, new_schema)

    bound_source = tab_source.get_bounds()
    pnt_center=Point(bound_source.center.x,bound_source.center.y,cs=tab_source.coordsystem)
    pnt_transf=pnt_center.affine_transform(transform)
    geo_rect = Rectangle(bound_source, cs=tab_source.coordsystem)
    new_geo = geo_rect.affine_transform(transform)
    out_bound = new_geo.bounds
    new_out_cs = CoordSystem.from_units(cs_out.unit, out_bound)
    new_schema = tab_source.schema
    new_schema.coordsystem = new_out_cs
    return CreateOutFile(path_out, new_schema)
path_source_js_transform=r"E:\Support\AxiomaTesting\RegisterTab\test_reg_rot_mif_tab.js_transform"
description_trasform=DescriptorTransform.factoryFromJson(path_source_js_transform)
invert_transform=description_trasform.transform.inverted()
tab_source_path=r"E:\Support\AxiomaTesting\RegisterTab\Test2Transform\test_reg_rot_mif_tab.tab"
tab_dest_path=r"E:\Support\AxiomaTesting\RegisterTab\test_reg_rot_invers.tab"
tab_source=provider_manager.openfile(tab_source_path)
tab_out=CreateOutTabFileInvert(tab_source,description_trasform.coordSystemTarget,invert_transform[0],tab_dest_path)
jkl=0
for ft in tab_source.items():
    geo_new=ft.geometry.affine_transform(invert_transform[0])
    geo_new.coordsystem=tab_out.coordsystem
    ft_new=FeatureClone(ft,geo_new)
    tab_out.insert([ft_new])