import os

import axipy
from axipy import Plugin, Position

from RegisterVector.ui.addTools.observer import factoryObserverMapAndTab
from RegisterVector.ui.dlgMainRegisterVector import RegisterVector
from RegisterVector.ui.dlgPacketTransform import DlgPacketTransfromTab


class PluginBuildPikets(Plugin):
    def __init__(self) -> None:
        self.__name_observer_tab="VectorTableOne"
        self.__name_observer_ready = "MapAndTab"
        self.__name_observer_map = "MapObserver"

        self.__observer=factoryObserverMapAndTab(self.__name_observer_ready, self.__name_observer_map, self.__name_observer_tab)
        self._title = self.tr("Регистрация векторов")

        local_file_icon_1 = os.path.join(os.path.dirname(os.path.realpath(__file__)), 'icons', 'regvector_32x32.png')
        local_file_icon_2 = os.path.join(os.path.dirname(os.path.realpath(__file__)), 'icons', 'regvector_32x32m2.png')
        self.__action_reg = self.create_action('Регистрация векторных данных',
                                           icon=local_file_icon_1, on_click=self.run_regVector,
                                           enable_on=self.__name_observer_ready)
        self.__action_transform = self.create_action('Трансформация векторных данных',
                                               icon=local_file_icon_2, on_click=self.run_RunTransformVector
                                               )
        position = Position('Дополнительно', 'Действие')
        position.add(self.__action_reg)
        position.add(self.__action_transform )
    def unload(self):
        self.__action_reg.remove()
        self.__action_transform.remove()
    def run_regVector(self):
        csl_reg = RegisterVector(axipy.mainwindow.qt_object())
        csl_reg.exec_()
        csl_reg.deleteLater()
    def run_RunTransformVector(self):

        cls_dlg = DlgPacketTransfromTab(axipy.mainwindow.qt_object())
        cls_dlg.exec_()
        cls_dlg.deleteLater()
