from PySide2 import QtCore
from PySide2.QtGui import QCursor
from PySide2.QtWidgets import QDialog
from axipy import data_manager, Layer, Map, MapView, view_manager

from RegisterVector.ui.add.helperMap import getMapView, getCloneMapView, cloneMap
from RegisterVector.ui.add.tempTablePoint import createTableAndAddToMap
from RegisterVector.ui.add.uiPoints import factoryClsPoinsValue, getButtonGroup
from RegisterVector.ui.helperUI import load_ui
from RegisterVector.ui.mapWidget import dlgMapWidget


class DlgRegisterVectors(QDialog):
    def __init__(self,parent=None):
        self.__cls_pointsCntrl_base_map=None
        super(DlgRegisterVectors, self).__init__(parent)
        self.__mapwidget=None
        self.__map_view_reg=None
        self.__mapwidget_reg=None
        self.__tempPointsTabMapTable=None
        self.__tempPointsTabBaseMap=None
        self.__cls_pointsCntrl_table_map=None
        self.ui = load_ui("DlgTestDialogMap8.ui", parent)
        self.__curent_base_map=None

        self.ui.cmb_base_maps.currentIndexChanged.connect(self.__change_map)
        self.ui.cmb_source_tab.currentIndexChanged.connect(self.__change_table)
        self.__initMapsAndTable()
        #start_tab="t1_reg"
        #self.__map_view_reg=self.__createMapViewForTab(start_tab)



        #map_view.widget.setCursor(QCursor(QtCore.Qt.CrossCursor))
        #map_view=getMapView("TatbReg")
        if self.__mapwidget is None:
            self.__mapwidget=dlgMapWidget(self.__curent_base_map,self.ui.group_base_map)

            self.ui.vrt_layot_base.addWidget(self.__mapwidget)
        self.__mapwidget.click_map.connect(self.__get_coord_base)
        #if self.__mapwidget_reg==None:
            #self.__mapwidget_reg = dlgMapWidget(self.__map_view_reg, self.ui.group_table_map)
            #self.ui.vrt_layot_reg.addWidget(self.__mapwidget_reg)
        self.__mapwidget_reg.click_map.connect(self.__get_coord_table_map)
        #self.__cls_pointsCntrl_base_map=factoryClsPoinsValue(self.ui.group_base_map)
        #self.__cls_pointsCntrl_table_map = factoryClsPoinsValue(self.ui.group_table_map)
        self.__button_grp_base_map=getButtonGroup(self.ui.group_base_map)
        self.__button_grp_table_map = getButtonGroup(self.ui.group_table_map)
        self.__button_grp_base_map.buttonClicked.connect(self.__select_edit_point_base)
        self.__button_grp_table_map.buttonClicked.connect(self.__select_edit_point_table)
        self.ui.finished.connect(self.__close)
    def show(self):
        self.ui.show()
    def __initMapsAndTable(self):
        for map_view in view_manager.mapviews:
            if map_view.coordsystem.lat_lon:
                continue
            self.ui.cmb_base_maps.addItem(map_view.title)
        for tab in data_manager.tables:
            if tab.coordsystem.lat_lon:
                continue
            self.ui.cmb_source_tab.addItem(tab.name)
        self.ui.cmb_source_tab.setCurrentIndex(0)
        self.ui.cmb_base_maps.setCurrentIndex(0)
    def __select_edit_point_base(self,button):
        print(self.__button_grp_base_map.id(button), button.text())
        self.__tempPointsTabBaseMap.setActiveId(self.__button_grp_base_map.id(button))

    def __select_edit_point_table(self,button):
        print(self.__button_grp_table_map.id(button), button.text())
        self.__tempPointsTabMapTable.setActiveId(self.__button_grp_table_map.id(button))
    def __get_coord_base(self,x,y):
        patern_xy = "x: {x:.5f} y: {y:.5f}"

        print(patern_xy.format(x=x, y=y))
        self.__tempPointsTabBaseMap.setPointXY(x,y)
        self.__enableRun()
    def __enableRun(self):
        count_point_base=self.__tempPointsTabBaseMap.countPoints()
        count_point_tab=self.__tempPointsTabMapTable.countPoints()
        if count_point_tab==3 and count_point_base==3:
            self.ui.pb_run.setEnabled(True)
        else:
            self.ui.pb_run.setEnabled(False)

    def __change_map(self,index):
        name_map = self.ui.cmb_base_maps.itemText(index)
        self.__change_map_widget(name_map)
    def __change_map_widget(self,name_map):
        old_map=self.__curent_base_map
        self.__curent_base_map = getCloneMapView(name_map)
        if self.__cls_pointsCntrl_base_map is None:
            self.__cls_pointsCntrl_base_map = factoryClsPoinsValue(self.ui.group_base_map)
        if self.__tempPointsTabBaseMap is not None:
            self.__tempPointsTabBaseMap.closeTable()
        self.__tempPointsTabBaseMap = createTableAndAddToMap(self.__curent_base_map, self.__cls_pointsCntrl_base_map)





        if self.__mapwidget is None:
            self.__mapwidget = dlgMapWidget(self.__curent_base_map, self.ui.group_base_map)

            self.ui.vrt_layot_base.addWidget(self.__mapwidget)
        else:
            self.__mapwidget.setNewMap(self.__curent_base_map)
        #if old_map is not None:
            #self.__closeMap(old_map)
    def __change_table(self,index):
        name_table=self.ui.cmb_source_tab.itemText(index)
        self.__change_map_table_reg(name_table)
    def __change_map_table_reg(self,name_table):
        if self.__map_view_reg is not None:

            #self.__map_view_reg.close()
            pass
        self.__map_view_reg=self.__createMapViewForTab(name_table)
        if self.__mapwidget_reg is None:
            self.__mapwidget_reg = dlgMapWidget(self.__map_view_reg, self.ui.group_table_map)
            self.ui.vrt_layot_reg.addWidget(self.__mapwidget_reg)
        else:
            self.__mapwidget_reg.setNewMap(self.__map_view_reg)
        if self.__cls_pointsCntrl_table_map is None:
            self.__cls_pointsCntrl_table_map = factoryClsPoinsValue(self.ui.group_table_map)
        if self.__tempPointsTabMapTable is not None:
            self.__tempPointsTabMapTable.closeTable()
        self.__tempPointsTabMapTable = createTableAndAddToMap(self.__map_view_reg, self.__cls_pointsCntrl_table_map)
    def __get_coord_table_map(self,x,y):
        patern_xy = "x: {x:.5f} y: {y:.5f}"

        print(patern_xy.format(x=x, y=y))
        self.__tempPointsTabMapTable.setPointXY(x, y)
        self.__enableRun()

    def __createMapViewForTab(self,name_tab):
        tab=data_manager.find(name_tab)
        layer=Layer.create(tab)
        layer.selectable=False
        map=Map([layer])
        map_vew=view_manager.create_mapview(map)
        return map_vew
    def __closeMap(self,map_view):
        if map_view is not None:
            try:
                map_view.close()
            except:
                pass
    def __close(self):
        pass
        '''
        if self.__map_view_reg is not None:
            try:
                self.__map_view_reg.close()
            except:
                pass
        if self.__curent_base_map is not None:
            try:
                self.__curent_base_map.close()
            except:
                pass
        '''