from PySide2.QtCore import Signal
from PySide2.QtWidgets import QDialog
from axipy import AxipyAnyCallableTask, task_manager

from RegisterVector.ui.add.add_ui.helperUI import load_ui


class dlgProgressBarMultiTask(QDialog):
    cancel_signal=Signal()
    def __init__(self,task_cls,parent=None):
        super().__init__(parent)
        self.ui = load_ui("dlg_progressMulti.ui", parent)
        self.__task=task_cls
        self.__task.update_second_progress.connect(self.__upate_second_progress)
        self.__task.finish_task.connect(self.__end_task)
    def setNameFile(self,name_tab):
        self.ui.message_text.setText(name_tab)
    def setMaxValue(self,max_value):
        self.ui.progressBar.setMaximum(max_value)
    def setMaxValueMain(self,max_value):
        self.ui.progress_tab.setMaximum(max_value)
    def setValueMain(self,value):
        self.ui.progress_tab.setValue(value)

    def __upate_second_progress(self,value):
        self.ui.progressBar.setValue(value)

    def show(self):
        #print("start 1")
        self.ui.show()
        self.__run_Task()
        #print("start 2")
    def __end_task(self):
        self.ui.close()
    def __run_Task(self):
        self.__multi_task=AxipyAnyCallableTask(self.__task.run, self)
        self.__multi_task.with_handler(True)
        task_manager.start_task(self.__multi_task)