from axipy import Feature, Table, Schema, provider_manager, Rectangle, CoordSystem


class CacheTable:
    def __init__(self,tab:Table,size=100):
        self.__tab=tab
        self.__size=size
        self.__cache=[]
    def add(self,ft:Feature):
        self.__cache.append(ft)
        if len(self.__cache)>self.__size:
            self.__tab.insert(self.__cache)
            self.__cache.clear()
    def end(self):
        if len(self.__cache)>0:
            self.__tab.insert(self.__cache)


def FeatureClone(ft: Feature, new_geo):
    attr_temp = ft.items()
    attr = {}
    for att in attr_temp:
        if att[0] == '+geometry' or att[0] == '+style':
            continue
        attr[att[0]] = att[1]

    return Feature(attr, geometry=new_geo, style=ft.style)
def CreateOutFile(path_out,schema:Schema):
    tab=provider_manager.tab.create_open(path_out,schema)
    return tab
def CreateOutTabFileInvert(tab_source: Table, cs_out: CoordSystem, transform, path_out):
    if not cs_out.non_earth:
        new_schema = tab_source.schema
        new_schema.coordsystem = cs_out
        return CreateOutFile(path_out, new_schema)

    bound_source = tab_source.get_bounds()

    geo_rect = Rectangle(bound_source, cs=tab_source.coordsystem)
    new_geo = geo_rect.affine_transform(transform)
    out_bound = new_geo.bounds
    new_out_cs = CoordSystem.from_units(cs_out.unit, out_bound)
    new_schema = tab_source.schema
    new_schema.coordsystem = new_out_cs
    return CreateOutFile(path_out, new_schema)