import time

from PySide2.QtCore import QObject, Signal
from axipy import AxipyProgressHandler, Table, Feature

from RegisterVector.ui.add.add_ui.table_helper import FeatureClone, CacheTable


class transformSingleTask(QObject):
    finish_task=Signal()
    def __init__(self,tab_source:Table,transform,tab_dest:Table):
        super().__init__()
        self.__tab_source=tab_source
        self.__tab_dest=tab_dest
        self.__transform=transform
        self.__count=self.__tab_source.count()
        self.__cls_cache_tab=CacheTable(self.__tab_dest,1000)
    def run(self,ph: AxipyProgressHandler,cls_progessBar):
        cls_progessBar.cancel_signal.connect(self.__set_cancel)
        cls_progessBar.setMaxValue(self.__count)
        self.__ph=ph
        ph.set_max_progress(self.__count)
        for i,ft in enumerate(self.__tab_source.items()):
            if ph.is_canceled():
                break
            geo_new = ft.geometry.affine_transform(self.__transform)
            geo_new.coordsystem = self.__tab_dest.coordsystem
            ft_new = FeatureClone(ft, geo_new)
            self.__cls_cache_tab.add(ft_new)
            ph.add_progress(1)
            cls_progessBar.setValue(i + 1)
            #time.sleep(1)
        self.__cls_cache_tab.end()
        self.__tab_dest.commit()
        self.finish_task.emit()
        return ph.progress()

    def __set_cancel(self):
        self.__ph.cancel()