from axipy import MapView, VectorLayer, Map, view_manager, Layer


def cloneMapWidget(map_widget:MapView):
    layers=map_widget.map.layers
    for layer in layers:
        if isinstance(layer,VectorLayer):
            layer.selectable=False
    new_map=Map(layers)
    return view_manager.create_mapview(new_map)
def cloneLayer(layer:Layer):
    new_layer=Layer.create(layer.data_object)
    new_layer.max_zoom=layer.max_zoom
    new_layer.min_zoom=layer.min_zoom
    new_layer.selectable=False
    new_layer.visible=layer.visible
    new_layer.zoom_restrict=layer.zoom_restrict
    new_layer.opacity=layer.opacity
    if isinstance(layer,VectorLayer):
        #new_layer.label=layer.label
        new_layer.linesDirectionVisibile=layer.linesDirectionVisibile
        new_layer.nodesVisible=layer.nodesVisible
        new_layer.overrideStyle=layer.overrideStyle
        new_layer.showCentroid=layer.showCentroid
        #new_layer.thematic=layer.thematic
    return new_layer
def cloneMap(map:Map):
    layers=[]
    for lyr in map.layers:
        layer=cloneLayer(lyr)
        if layer is not None:
            layers.append(layer)
    return Map(layers)
def getMapView(name_map):

    for view_map in view_manager.mapviews:
        if view_map.title==name_map:
            return view_map
    return None
def getCloneMapView(name_map):
    map_view=getMapView(name_map)
    map_clone=cloneMap(map_view.map)
    map_view_clone=view_manager.create_mapview(map_clone)
    map_view_clone.coordsystem=map_view.coordsystem
    map_view_clone.snap_mode=True
    map_view_clone.center=map_view.center
    map_view_clone.scale=map_view.scale

    return map_view_clone

