import axipy
from axipy import data_manager, ObserverManager, view_manager


def factoryObserverTabVector(name_observer,count_tab=1):
    def isExistVectorTableCount(count_table=1,isRemove=False):
        count=0
        tabs=data_manager.tables
        if len(tabs)<count_tab:
            return False
        for tab in tabs:
            if isTableVector(tab):
                count=count+1
                if not isRemove:
                    if count>=count_table:
                        return True
        if isRemove:
            if (count-1)<count_table:
                return False
            else:
                return True
        return False

    def isTableVector(obj):
        if not isinstance(obj, axipy.Table):
            return False
        if not obj.is_spatial:
            return False
        try:
            schema_tab = obj.schema
            if schema_tab is None:
                return False
        except:
            return False
        return True
    def existVectorTable(name_table=None):
        count_vector = 0
        for tab in data_manager.tables:
            if tab.name == name_table:
                continue
            if isTableVector(tab):
                count_vector = count_vector + 1
        if count_vector == 0:
            return False
        return True
    observer=None
    try:
        observer=ObserverManager.get(name_observer)
    except:
        pass
    if observer is None:
        observer=ObserverManager.create(name_observer,False)
        def addTable(name_table=None):
            if observer.value:
                return
            observer.value = isExistVectorTableCount(count_tab)


            return

        def removedTable(name_table):
            observer.value = isExistVectorTableCount(count_tab,True)

            return
        def selectCount():
            tabs_for_grid =  axipy.da.data_manager.tables
            count_source=len(tabs_for_grid)
            if count_source<=1:
                observer.value=False
                return
            observer.value=True

            return
        def addChildrenWidget(name_tool,widget):
            observer.children_widgets[name_tool]=widget
        def removeChildrenWidget(name):
            try:
                del observer.children_widgets[name]
            except:
                pass

        setattr(observer, "children_widgets", {})
        setattr(observer, "addTable", addTable)
        setattr(observer, "removedTable", removedTable)
        #setattr(observer, "selectCount", selectCount)

        axipy.da.data_manager.added.connect(addTable)
        axipy.da.data_manager.removed.connect(removedTable)
        #axipy.gui.selection_manager.changed.connect(observer.selectCount)
        observer.value=isExistVectorTableCount(count_tab)
    return observer
def factoryObserverMap(name_observer):
    observer = None
    try:
        observer = ObserverManager.get(name_observer)
    except:
        pass
    if observer is None:
        observer = ObserverManager.create(name_observer, False)
    def changeMapView():
        if len(view_manager.mapviews)==0:
            observer.value=False
        for map_view in view_manager.mapviews:
            if not map_view.coordsystem.lat_lon:
                observer.value=True
                return

    setattr(observer, "changeMapView", changeMapView)
    view_manager.count_changed.connect(changeMapView)
    changeMapView()
    return observer
def factoryObserverMapAndTab(name_observer,name_map_observer,name_tab_observer):
    observer = ObserverManager.get(name_observer)
    if observer is not None:
        return observer
    observer = ObserverManager.create(name_observer, False)
    observer_map=ObserverManager.get(name_map_observer)
    if observer_map is None:
        observer_map=factoryObserverMap(name_map_observer)

    observer_tab=ObserverManager.get(name_tab_observer)
    if observer_tab is None:
        observer_tab=factoryObserverTabVector(name_tab_observer)
    def changeStatusMapObserver():
        if observer_tab.value and observer_tab.value:
            observer.value=True
        else:
            observer.value=False
    observer_map.changed.connect(changeStatusMapObserver)
    observer_tab.changed.connect(changeStatusMapObserver)
    changeStatusMapObserver()
    return observer





