from PySide2.QtCore import Signal
from PySide2.QtWidgets import QWidget, QVBoxLayout

from RegisterVector.ui.add.helperMap import cloneMapWidget


class dlgMapWidget(QWidget):
    click_map=Signal(float,float)
    def __init__(self, map_view, parent=None):
        #super(dlgMapWidget, self).__init__(parent)
        super().__init__(parent)
        self.__curent_map_view = map_view
        self.__curent_map_view.snap_mode = True
        self.__layout = QVBoxLayout()
        self.__layout.setContentsMargins(0, 0, 0, 0)
        self.__layout.addWidget(self.__curent_map_view.widget)
        self.setLayout(self.__layout)
        #self.__curent_map_view.widget.setParent(parent)
        self.__curent_map_view.mouse_moved.connect(self.__mouse_move_in_map)
        self.__x_last=None
        self.__y_last=None

    def mouseDoubleClickEvent(self, mouse_event):
        print("Mouse Double-Click")
        self.click_map.emit(self.__x_last,self.__y_last)

    def __mouse_move_in_map(self,x,y):
        self.__x_last=x
        self.__y_last=y

    def setNewMap(self,map_view):
        self.__curent_map_view.mouse_moved.disconnect(self.__mouse_move_in_map)
        self.__clearLayout(self.__layout)
        self.__curent_map_view=map_view
        self.__layout.addWidget(self.__curent_map_view.widget)
        self.__curent_map_view.mouse_moved.connect(self.__mouse_move_in_map)
    def removeMapWidget(self):
        self.__curent_map_view.mouse_moved.disconnect(self.__mouse_move_in_map)
        self.__clearLayout(self.__layout)
    def __clearLayout(self,layout):
        if layout is not None:
            while layout.count():
                child = layout.takeAt(0)
                if child.widget() is not None:
                    child.widget().deleteLater()
                elif child.layout() is not None:
                    self.__clearLayout(child.layout())



