from PySide2.QtGui import QCursor, Qt
from PySide2.QtWidgets import QWidget
from axipy import view_manager, MapTool

from RegisterVector.ui.add.helperMap import cloneMap


from RegisterVector.ui.helperUI import load_ui, clearlayout


class WidgetMapReg(QWidget):
    def __init__(self,parent=None):
        self.__parentWin=parent
        self.ui = load_ui("widgetMap.ui", parent)
        super(WidgetMapReg, self).__init__(parent)
        #self.__map_tool=MyTool()
        #self.__map_tool.enable_on=True

        self.__curent_map_view=None


    def show(self):
        self.ui.show()
    def setActiveMap(self,map_view):
        if self.__curent_map_view is not None:
            self.__curent_map_view.close()
            clearlayout(self.ui.mapLayout)
        map=cloneMap(map_view.map)
        self.__curent_map_view=view_manager.create_mapview(map)
        self.__curent_map_view.snap_mode=True

        self.ui.mapLayout.addWidget(self.__curent_map_view.widget)
        self.ui.mousePressEvent = self.mousePressEvent
        self.__curent_map_view.mouse_moved.connect(self.__mouse_move_in_map)
        widget_map=self.__curent_map_view.widget

        #self.__curent_map_view.widget.mouseDoubleClickEvent=self.__mousePressEvent
        #widget_map.mouseDoubleClickEvent(None)
        jkl=0


    def __mouse_move_in_map(self, x,y):
        patern_xy="x: {x:.5f} y: {y:.5f}"
        print("Mouse move")
        print(patern_xy.format(x=x,y=y))

    def __mousePressEvent(self, event) -> bool:
        print("mouseEvent")
        if event is None:
            return
        if event.button() == Qt.LeftButton:
            self.cursor = QCursor(Qt.SizeAllCursor)

    def mousePressEvent(self, event):
        print('mousePressEvent')
        self.startingposx = event.x()
        super().mousePressEvent(event)

    def mouseReleaseEvent(self, event):
        print('mouseReleaseEvent')
        self.endingposx = event.x()
        super().mouseReleaseEvent(event)
