import os

import axipy
from PySide2.QtCore import QFile
from PySide2.QtUiTools import QUiLoader
from PySide2.QtWidgets import QDialog
from axipy import provider_manager, Layer, Map, view_manager, Rect

from .helperMap import cloneMap


class DlgMap(QDialog):
    def __init__(self,parent=None):
        self.__parentWin=parent
        super(DlgMap, self).__init__(parent)
        self.load_ui("DlgTest2.ui")
        self.ui.finished.connect(self.__closeDlg)
        self.__clone_mapview=None
    def load_ui(self,name_resource):
        loader = QUiLoader()
        path = os.path.join(os.path.dirname(__file__),name_resource)
        ui_file = QFile(path)
        ui_file.open(QFile.ReadOnly)
        self.ui  = loader.load(ui_file,self.__parentWin)

        ui_file.close()
    def show(self):
        self.ui.show()
        list_map_view=view_manager.mapviews

        self.__clone_map = cloneMap(list_map_view[0].map)
        self.__clone_mapview = view_manager.create_mapview(self.__clone_map)
        self.__clone_mapview.snap_mode=True
        rect = self.ui.mapLayout.geometry()
        #self.__clone_mapview.rect = Rect(0, 0, rect.width(), rect.height())
        ''' Отображение карты существующей '''
        #list_map_view[0].snap_mode=True
        #self.ui.mapLayout.addWidget(list_map_view[0].widget)
        ''' Отображение карты ( клона)'''
        self.ui.mapLayout.addWidget(self.__clone_mapview.widget)

    def __closeDlg(self, evnt):
        if self.__clone_mapview is not None:
            self.__clone_mapview.close()

path_tab=r"E:\New RF\SubjectRF.TAB"
tab_rf=provider_manager.openfile(path_tab)
layer_sub_rf=Layer.create(tab_rf)
map_1=Map([layer_sub_rf])
map_v1=view_manager.create_mapview(map_1)
cls_Dlg_map=DlgMap(axipy.mainwindow.qt_object())
cls_Dlg_map.show()